/*
 *	CERCA.C
 *	LaMoSca (LAboratorio di MOtori per SCAcchi)
 *	versione 0.07
 *	2001 Pietro Valocchi
 */


#include <stdio.h>
#include "Common.h"
#include "Extern.h"


/* NegaMax() ricerca NegaMax */
BOOL NegaMax(Mossa *M, int *ValorePosizione) {

	int i, ValoreCorrente;
	BOOL Trovata = FALSE;

	/* genera mosse */
	GeneraPseudo();

	/* verifica che il re non sia in scacco */
	for (i = InizioMosse[Livello-1]; i < InizioMosse[Livello]; i++) {
		if (B[StackMosse[i].A].Pezzo == RE) {
			return FALSE;
		}
	}

	/* valuta la posizione se siamo al livello massimo */
	if (Livello == (LivelloMassimo + 1)) {
		*ValorePosizione = Valuta();
		return TRUE;
	} else {

		/* prova tutte le mosse fino a trovare la migliore */
		if (LogFile) fprintf(LogFile, "\nLivello %d: ", Livello);

		*ValorePosizione = - INFINITO;

		for (i = InizioMosse[Livello-1]; i < InizioMosse[Livello]; i++) {

			/* esegui la mossa */
			Muovi(&StackMosse[i]);

			/* trova la risposta migliore per l'avversario */
			if (NegaMax(M, &ValoreCorrente)) {
				Trovata = TRUE;

				/* massimizza il valore della posizione */
				ValoreCorrente = - ValoreCorrente;
				if ((ValoreCorrente) > *ValorePosizione) {
					*ValorePosizione = ValoreCorrente;
					/* salva la mossa scelta */
					if (Livello == 2) {
						M->A  = StackMosse[i].A;
						M->Da = StackMosse[i].Da;
					}
				}
			}
			/* ripristina la mossa */
			TornaIndietro(&StackMosse[i]);

			if (LogFile)
				fprintf(LogFile, "L%d%c%d%c%d=%d ",  Livello, 
				COLONNA(StackMosse[i].Da)+ 'a', 8 - RIGA(StackMosse[i].Da), 
				COLONNA(StackMosse[i].A) + 'a', 8 - RIGA(StackMosse[i].A),
				ValoreCorrente);
		}

		if (LogFile) {
			fprintf(LogFile, "\nRisultato L%d: T=%d", Livello, Trovata);
			if (Trovata == TRUE) {
				if (Livello == 1)
					fprintf(LogFile, ", M=%c%d%c%d",
					COLONNA(M->Da)+ 'a', 8 - RIGA(M->Da), 
					COLONNA(M->A) + 'a', 8 - RIGA(M->A));
				fprintf(LogFile, ", V=%d", *ValorePosizione);
			}
			fprintf(LogFile, "\n");
		}
	}

	return Trovata;
}


